/** 
  Wird bei Tastendruck bzw Tastenkombination aufgerufen
  @param key ... gedrueckte F Taste
  @param mod ... gedrueckte modifier Taste
*/
main(int key, int mod) 
{ 
  if ( stdTraffic_hmi_getFrameworkName() == "EBO" )//EBO Framework
  {
    if ( key == KEY_F2 )//ummelden
      ChildPanelOnCentralModal("hmi/ebo/login.xml", "Login", makeDynString());
    else if ( key == KEY_F3 )//abmelden
      stdTraffic_hmi_logout();
    else if ( key == KEY_F6 )//lampentest
      stdTraffic_hmi_setLampentestState(!stdTraffic_hmi_getLampentestState());//Lampentest
    else if ( key == KEY_F7 )//hupenquittierung
      stdTraffic_horn_ackHorn();
    else if ( key == KEY_F8 )//alarm quittieren
      stdTraffic_hmi_ackScreen();
    else if ( key == KEY_F10 )//bildaufschaltung speichern und videos speichern
    {
      dyn_string dsDefaultPanel;
      dpGet ("sys_user_" + getUserName () + ".defaultPanel", dsDefaultPanel);
  
      for (int i=1; i<=getScreenCount (); i++)
      {
        if (glob_mScreen[i]["panelName"] != "")
        {
          dsDefaultPanel[i] = glob_mScreen[i]["panelName"] + "@" + glob_mScreen[i]["panelPosX"] + "@" + glob_mScreen[i]["panelPosY"];
        }
      }

      dpSet ("sys_user_" + getUserName () + ".defaultPanel", dsDefaultPanel);
      
      //videoaufschaltung speichern;
      string sWorkstation = strtolower(getHostname());
      
      dyn_string dsIds;
      dyn_string dsSources;
      dyn_int diX;
      dyn_int diY;
      
      dpGet("barco_workstation_"+sWorkstation+".workspace.visualObjects.id", dsIds,
            "barco_workstation_"+sWorkstation+".workspace.visualObjects.sourceName", dsSources,
            "barco_workstation_"+sWorkstation+".workspace.visualObjects.x", diX,
            "barco_workstation_"+sWorkstation+".workspace.visualObjects.y", diY);
      
      //sortierung
      dyn_dyn_anytype dda;
      dda[1] = dsIds;
      dda[2] = diY;
      dda[3] = diX;
      dda[4] = dsSources;

      dynDynTurn(dda);
      dynDynSort(dda, makeDynInt(3));
      dynDynSort(dda, makeDynInt(2));
      dynDynTurn(dda);

      dsIds = dda[1];
      diY = dda[2];
      diX = dda[3];
      dsSources = dda[4];
      
      for ( int i = dynlen(dsIds); i > 0; i-- )
      {
        if ( strpos(dsIds[i], "_frame") != -1 )//keine frames speichern
        {
          dynRemove(dsIds, i);
          dynRemove(dsSources, i);
        }
      }

      dpSet("sys_user_"+getUserName()+".defaultVideo", dsSources);
    }
    else if ( key == KEY_F12 )//screenshot speichern
    {
      string sPath;
      folderSelector(sPath);
      string sTime = getCurrentTime();
      strreplace(sTime," ","_");
      strreplace(sTime,".","_");
      strreplace(sTime,":","_");
      setValue("main_"+stdTraffic_hmi_getScreenName(myModuleName()) + "." + "main.xml" + ":", "imageToFile",sPath+ "/Screenshot_"+sTime+".png");
    }
  }
}
